From f20473bfcee700adea7ec81ba3152c12b1a8aedf Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 12 2017 16:30:33 +0000
Subject: [PATCH 33/51] check components


---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index 5842f9b..6e28eb0 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -106,6 +106,11 @@ class ModuleMDLinter(object):
 
     yaml_scalar_types = (str, int, float)
 
+    recognized_rpm_keys = {'rationale', 'buildorder', 'repository', 'ref',
+                           'cache', 'arches', 'multilib'}
+
+    recognized_module_keys = {'rationale', 'buildorder', 'repository', 'ref'}
+
     def __init__(self, modulemd_path=None, modulemd_str=None):
         if bool(modulemd_path) == bool(modulemd_str):
             raise ValueError(
@@ -575,3 +580,105 @@ class ModuleMDLinter(object):
         if 'filter' in self.mmd:
             for block in self.mmd['filter'].values():
                 self.check_is_scalar(*block)
+
+    @error
+    @guidelines_link('#Module_components')
+    @detail("The 'components' block must be a dictionary (key/value).")
+    def lint_components_dict(self):
+        """Modules MAY, and most modules do contain a components block defining
+        the module's content."""
+        if 'components' in self.mmd:
+            self.check_is_dict(self.mmd['components'])
+
+    @warning
+    @guidelines_link('#Module_components')
+    @detail("The 'components' block only recognizes 'rpms' and 'modules' as"
+            " keys.")
+    @prerequisite('components_dict')
+    def lint_components_keys(self):
+        """Modules MAY, and most modules do contain a components block defining
+        the module's content. RPM packages and other modules are the only
+        currently supported content types."""
+        if 'components' in self.mmd:
+            self.check(set(self.mmd['components']) <= {'rpms', 'modules'})
+
+    @error
+    @guidelines_link('#Module_components')
+    @detail("All 'components' blocks must be dictionaries (key/value).")
+    @prerequisite('components_dict')
+    def lint_components_blocks_dict(self):
+        """Modules MAY, and most modules do contain a components block defining
+        the module's content."""
+        if 'components' in self.mmd:
+            self.check_is_dict(*self.mmd['components'].values())
+
+    @error
+    @guidelines_link('#Module_components')
+    @detail("All 'components/*' blocks must be dictionaries (key/value).")
+    @prerequisite('components_blocks_dict')
+    def lint_components_subblocks_dict(self):
+        """Modules MAY, and most modules do contain a components block defining
+        the module's content."""
+        if 'components' in self.mmd:
+            self.check_is_dict(*(subblock
+                                 for block in self.mmd['components'].values()
+                                 for subblock in block.values()))
+
+    @warning
+    @guidelines_link('#Module_components')
+    @detail("One or more 'components' block is empty.")
+    @prerequisite('components_blocks_dict')
+    def lint_components_blocks_empty(self):
+        """Modules MAY, and most modules do contain a components block defining
+        the module's content."""
+        if 'components' in self.mmd:
+            self.check(all(self.mmd['components'].values()))
+
+    @warning
+    @guidelines_link('#Module_components')
+    @detail("One or more 'components/*' block is empty.")
+    @prerequisite('components_blocks_dict')
+    def lint_components_subblocks_empty(self):
+        """Modules MAY, and most modules do contain a components block defining
+        the module's content."""
+        if 'components' in self.mmd:
+            self.check(all(subblock
+                           for block in self.mmd['components'].values()
+                           for subblock in block.values()))
+
+    @error
+    @guidelines_link('#Module_components')
+    @prerequisite('components_subblocks_dict')
+    def lint_components_blocks_mandatory_keys(self):
+        """Every component MUST declare why it was added to the module, its
+        'rationale'."""
+        if 'components' in self.mmd:
+            for block in self.mmd['components'].values():
+                for subblock in self.mmd['components']['rpms'].values():
+                    self.check('rationale' in subblock)
+                    self.check_is_scalar(subblock['rationale'])
+
+    @warning
+    @guidelines_link('#RPM_content')
+    @detail("Recognized keys are: {}".format(
+        ", ".join("'{}'".format(k) for k in recognized_rpm_keys)))
+    @prerequisite('components_subblocks_dict')
+    def lint_components_rpms_recognized_keys(self):
+        """Module RPM content is defined in the 'rpms' block of
+        'components'."""
+        if 'rpms' in self.mmd.get('components', {}):
+            self.check(all(set(b) <= self.recognized_rpm_keys
+                           for b in self.mmd['components']['rpms'].values()))
+
+    @warning
+    @guidelines_link('#Module_content')
+    @detail("Recognized keys are: {}".format(
+        ", ".join("'{}'".format(k) for k in recognized_module_keys)))
+    @prerequisite('components_subblocks_dict')
+    def lint_components_modules_recognized_keys(self):
+        """Including modules as content is defined in the 'modules' block of
+        'components'."""
+        if 'modules' in self.mmd.get('components', {}):
+            self.check(
+                all(set(b) <= self.recognized_module_keys
+                    for b in self.mmd['components']['modules'].values()))

